Linux localhost 6.1.10-x86_64-linode159 #1 SMP PREEMPT_DYNAMIC Wed Feb 8 14:14:45 EST 2023 x86_64
Apache/2.4.25 (Debian)
Server IP : 45.33.61.127 & Your IP : 216.73.216.156
Domains :
Cant Read [ /etc/named.conf ]
User : www-data
Terminal
Auto Root
Create File
Create Folder
Localroot Suggester
Backdoor Destroyer
Readme
/
usr /
bin /
Delete
Unzip
Name
Size
Permission
Date
Action
2to3
96
B
-rwxr-xr-x
2020-08-22 10:03
2to3-2.7
96
B
-rwxr-xr-x
2020-08-22 10:03
2to3-3.5
96
B
-rwxr-xr-x
2020-11-18 21:09
[
50.79
KB
-rwxr-xr-x
2017-02-22 12:23
ab
50.18
KB
-rwxr-xr-x
2019-10-13 15:43
addpart
22.53
KB
-rwxr-xr-x
2018-03-07 18:29
apropos
46.98
KB
-rwxr-xr-x
2016-12-13 13:10
apt
14.09
KB
-rwxr-xr-x
2020-12-07 12:45
apt-cache
78.16
KB
-rwxr-xr-x
2020-12-07 12:45
apt-cdrom
22.16
KB
-rwxr-xr-x
2020-12-07 12:45
apt-config
22.09
KB
-rwxr-xr-x
2020-12-07 12:45
apt-extracttemplates
22.16
KB
-rwxr-xr-x
2020-12-07 12:45
apt-ftparchive
238.16
KB
-rwxr-xr-x
2020-12-07 12:45
apt-get
42.16
KB
-rwxr-xr-x
2020-12-07 12:45
apt-key
25.65
KB
-rwxr-xr-x
2020-12-07 12:45
apt-listchanges
8.88
KB
-rwxr-xr-x
2017-04-10 21:14
apt-mark
42.16
KB
-rwxr-xr-x
2020-12-07 12:45
apt-sortpkgs
38.09
KB
-rwxr-xr-x
2020-12-07 12:45
arch
34.76
KB
-rwxr-xr-x
2017-02-22 12:23
aria_chk
4.76
MB
-rwxr-xr-x
2021-01-31 16:38
aria_dump_log
4.56
MB
-rwxr-xr-x
2021-01-31 16:38
aria_ftdump
4.58
MB
-rwxr-xr-x
2021-01-31 16:38
aria_pack
4.6
MB
-rwxr-xr-x
2021-01-31 16:38
aria_read_log
4.72
MB
-rwxr-xr-x
2021-01-31 16:38
awk
646.72
KB
-rwxr-xr-x
2017-01-25 16:06
b2sum
54.88
KB
-rwxr-xr-x
2017-02-22 12:23
base32
38.79
KB
-rwxr-xr-x
2017-02-22 12:23
base64
38.79
KB
-rwxr-xr-x
2017-02-22 12:23
basename
30.73
KB
-rwxr-xr-x
2017-02-22 12:23
bashbug
6.95
KB
-rwxr-xr-x
2017-05-15 19:45
bootctl
38.41
KB
-rwxr-xr-x
2019-07-21 18:43
bsd-from
10.3
KB
-rwxr-xr-x
2017-04-12 11:22
bsd-write
14.42
KB
-rwxr-sr-x
2017-04-12 11:22
buildhash
38.38
KB
-rwxr-xr-x
2016-03-04 07:59
busctl
62.43
KB
-rwxr-xr-x
2019-07-21 18:43
c2ph
35.89
KB
-rwxr-xr-x
2020-06-20 17:33
c_rehash
6.18
KB
-rwxr-xr-x
2020-12-11 09:22
cal
29.21
KB
-rwxr-xr-x
2017-04-12 11:22
calendar
31.24
KB
-rwxr-xr-x
2017-04-12 11:22
captoinfo
78.11
KB
-rwxr-xr-x
2017-12-28 09:47
catchsegv
3.22
KB
-rwxr-xr-x
2019-02-06 21:17
catman
34.46
KB
-rwxr-xr-x
2016-12-13 13:10
certbot
385
B
-rwxr-xr-x
2020-09-26 18:25
chage
70.17
KB
-rwxr-sr-x
2017-05-17 11:59
chardet3
309
B
-rwxr-xr-x
2016-02-10 10:46
chardetect3
309
B
-rwxr-xr-x
2016-02-10 10:46
chattr
14
KB
-rwxr-xr-x
2020-07-25 09:03
chcon
63.01
KB
-rwxr-xr-x
2017-02-22 12:23
checkgid
5.99
KB
-rwxr-xr-x
2019-10-13 15:43
chfn
48.87
KB
-rwsr-xr-x
2017-05-17 11:59
chrt
30.76
KB
-rwxr-xr-x
2018-03-07 18:29
chsh
39.55
KB
-rwsr-xr-x
2017-05-17 11:59
cifsiostat
30.13
KB
-rwxr-xr-x
2017-05-25 20:26
ckbcomp
146.32
KB
-rwxr-xr-x
2017-04-07 03:55
cksum
34.76
KB
-rwxr-xr-x
2017-02-22 12:23
clear
5.99
KB
-rwxr-xr-x
2017-12-28 09:47
clear_console
10.3
KB
-rwxr-xr-x
2017-05-15 19:45
cmp
42.74
KB
-rwxr-xr-x
2017-01-09 22:55
codepage
10.27
KB
-rwxr-xr-x
2016-01-05 16:55
col
10.29
KB
-rwxr-xr-x
2017-04-12 11:22
colcrt
10.26
KB
-rwxr-xr-x
2017-04-12 11:22
colrm
10.25
KB
-rwxr-xr-x
2017-04-12 11:22
column
14.41
KB
-rwxr-xr-x
2017-04-12 11:22
comm
38.79
KB
-rwxr-xr-x
2017-02-22 12:23
compose
17.74
KB
-rwxr-xr-x
2016-05-01 11:20
corelist
12.53
KB
-rwxr-xr-x
2020-06-20 17:33
cpan
7.41
KB
-rwxr-xr-x
2020-06-20 17:33
cpan5.24-x86_64-linux-gnu
7.43
KB
-rwxr-xr-x
2020-06-20 17:33
crontab
39.32
KB
-rwxr-sr-x
2017-10-07 13:38
csplit
46.95
KB
-rwxr-xr-x
2017-02-22 12:23
ctstat
18.8
KB
-rwxr-xr-x
2017-11-24 09:22
curl
194.07
KB
-rwxr-xr-x
2020-12-17 19:12
cut
42.85
KB
-rwxr-xr-x
2017-02-22 12:23
dbilogstrip
1.35
KB
-rwxr-xr-x
2020-09-21 15:33
dbiprof
6.06
KB
-rwxr-xr-x
2020-09-21 15:33
dbiproxy
5.27
KB
-rwxr-xr-x
2020-09-21 15:33
dbus-cleanup-sockets
9.98
KB
-rwxr-xr-x
2020-07-02 19:36
dbus-daemon
218.95
KB
-rwxr-xr-x
2020-07-02 19:36
dbus-monitor
21.99
KB
-rwxr-xr-x
2020-07-02 19:36
dbus-run-session
9.98
KB
-rwxr-xr-x
2020-07-02 19:36
dbus-send
25.98
KB
-rwxr-xr-x
2020-07-02 19:36
dbus-update-activation-environment
13.98
KB
-rwxr-xr-x
2020-07-02 19:36
dbus-uuidgen
9.98
KB
-rwxr-xr-x
2020-07-02 19:36
deallocvt
10.38
KB
-rwxr-xr-x
2016-01-05 16:55
deb-systemd-helper
19.67
KB
-rwxr-xr-x
2017-05-02 10:20
deb-systemd-invoke
4.4
KB
-rwxr-xr-x
2017-05-02 10:20
debconf
2.79
KB
-rwxr-xr-x
2017-05-21 17:08
debconf-apt-progress
11.27
KB
-rwxr-xr-x
2017-05-21 17:08
debconf-communicate
608
B
-rwxr-xr-x
2017-05-21 17:08
debconf-copydb
1.68
KB
-rwxr-xr-x
2017-05-21 17:08
debconf-escape
647
B
-rwxr-xr-x
2017-05-21 17:08
debconf-set-selections
2.87
KB
-rwxr-xr-x
2017-05-21 17:08
debconf-show
1.78
KB
-rwxr-xr-x
2017-05-21 17:08
defmt-c
5.99
KB
-rwxr-xr-x
2016-03-04 07:59
defmt-sh
5.99
KB
-rwxr-xr-x
2016-03-04 07:59
delpart
22.53
KB
-rwxr-xr-x
2018-03-07 18:29
dh_bash-completion
2.49
KB
-rwxr-xr-x
2015-08-18 19:47
dh_installxmlcatalogs
9.22
KB
-rwxr-xr-x
2016-11-07 14:53
dh_perl_dbi
1.04
KB
-rwxr-xr-x
2020-09-21 15:33
dh_pypy
12.56
KB
-rwxr-xr-x
2017-01-25 14:47
dh_python2
1.03
KB
-rwxr-xr-x
2017-01-24 13:00
dh_python3
12.77
KB
-rwxr-xr-x
2017-01-25 14:47
diff
143.38
KB
-rwxr-xr-x
2017-01-09 22:55
diff3
58.95
KB
-rwxr-xr-x
2017-01-09 22:55
dircolors
42.77
KB
-rwxr-xr-x
2017-02-22 12:23
dirname
30.73
KB
-rwxr-xr-x
2017-02-22 12:23
discover-config
2.86
KB
-rwxr-xr-x
2018-02-26 19:38
dotlockfile
18.56
KB
-rwxr-sr-x
2017-01-17 13:05
dpkg
286.5
KB
-rwxr-xr-x
2018-06-26 10:28
dpkg-deb
146.34
KB
-rwxr-xr-x
2018-06-26 10:28
dpkg-divert
138.41
KB
-rwxr-xr-x
2018-06-26 10:28
dpkg-maintscript-helper
18.58
KB
-rwxr-xr-x
2018-06-26 10:28
dpkg-query
146.4
KB
-rwxr-xr-x
2018-06-26 10:28
dpkg-split
114.34
KB
-rwxr-xr-x
2018-06-26 10:28
dpkg-statoverride
70.25
KB
-rwxr-xr-x
2018-06-26 10:28
dpkg-trigger
66.26
KB
-rwxr-xr-x
2018-06-26 10:28
du
103.16
KB
-rwxr-xr-x
2017-02-22 12:23
dumpkeys
162.98
KB
-rwxr-xr-x
2016-01-05 16:55
dvipdf
1023
B
-rwxr-xr-x
2020-08-20 14:04
easy_install3
404
B
-rwxr-xr-x
2017-01-19 17:02
edit
17.74
KB
-rwxr-xr-x
2016-05-01 11:20
editor
220.04
KB
-rwxr-xr-x
2017-01-11 02:10
enc2xs
40.21
KB
-rwxr-xr-x
2020-06-20 17:33
encguess
2.99
KB
-rwxr-xr-x
2020-06-20 17:33
env
30.76
KB
-rwxr-xr-x
2017-02-22 12:23
envsubst
34.7
KB
-rwxr-xr-x
2019-08-30 23:30
eps2eps
639
B
-rwxr-xr-x
2020-08-20 14:04
eqn
185.19
KB
-rwxr-xr-x
2016-12-13 13:06
ex
2.3
MB
-rwxr-xr-x
2019-06-21 04:10
expand
34.79
KB
-rwxr-xr-x
2017-02-22 12:23
expiry
22.27
KB
-rwxr-sr-x
2017-05-17 11:59
expr
42.82
KB
-rwxr-xr-x
2017-02-22 12:23
factor
74.88
KB
-rwxr-xr-x
2017-02-22 12:23
faillog
18.29
KB
-rwxr-xr-x
2017-05-17 11:59
fallocate
26.64
KB
-rwxr-xr-x
2018-03-07 18:29
fcgistarter
9.99
KB
-rwxr-xr-x
2019-10-13 15:43
filan
83.85
KB
-rwxr-xr-x
2017-07-14 13:52
file
22.26
KB
-rwxr-xr-x
2019-10-22 20:20
file-rename
3.1
KB
-rwxr-xr-x
2015-06-04 22:55
find
216.57
KB
-rwxr-xr-x
2017-02-18 15:37
findaffix
11.74
KB
-rwxr-xr-x
2016-03-04 07:59
flock
26.79
KB
-rwxr-xr-x
2018-03-07 18:29
fmt
38.79
KB
-rwxr-xr-x
2017-02-22 12:23
fold
34.79
KB
-rwxr-xr-x
2017-02-22 12:23
free
18.08
KB
-rwxr-xr-x
2018-05-17 10:56
from
10.3
KB
-rwxr-xr-x
2017-04-12 11:22
futurize
384
B
-rwxr-xr-x
2016-09-23 17:38
galera_new_cluster
888
B
-rwxr-xr-x
2021-01-31 16:38
galera_recovery
3.28
KB
-rwxr-xr-x
2021-01-31 16:38
gawk
646.72
KB
-rwxr-xr-x
2017-01-25 16:06
geqn
185.19
KB
-rwxr-xr-x
2016-12-13 13:06
getconf
22.37
KB
-rwxr-xr-x
2019-02-06 21:17
getent
23.31
KB
-rwxr-xr-x
2019-02-06 21:17
getkeycodes
10.37
KB
-rwxr-xr-x
2016-01-05 16:55
getopt
14.49
KB
-rwxr-xr-x
2018-03-07 18:29
gettext
34.68
KB
-rwxr-xr-x
2019-08-30 23:30
gettext.sh
4.52
KB
-rwxr-xr-x
2019-08-30 23:30
ghostscript
10.24
KB
-rwxr-xr-x
2020-08-20 14:04
gpasswd
74.02
KB
-rwsr-xr-x
2017-05-17 11:59
gpg
977.35
KB
-rwxr-xr-x
2019-02-07 20:57
gpg-agent
376.63
KB
-rwxr-xr-x
2019-02-07 20:57
gpg-connect-agent
150.73
KB
-rwxr-xr-x
2019-02-07 20:57
gpg-zip
3.36
KB
-rwxr-xr-x
2019-02-07 20:57
gpgconf
157.41
KB
-rwxr-xr-x
2019-02-07 20:57
gpgparsemail
26.07
KB
-rwxr-xr-x
2019-02-07 20:57
gpgsplit
74.33
KB
-rwxr-xr-x
2019-02-07 20:57
gpgv
410.64
KB
-rwxr-xr-x
2019-02-07 20:57
gpic
196.03
KB
-rwxr-xr-x
2016-12-13 13:06
groff
101.31
KB
-rwxr-xr-x
2016-12-13 13:06
grog
2.71
KB
-rwxr-xr-x
2016-12-13 13:06
grops
161.72
KB
-rwxr-xr-x
2016-12-13 13:06
grotty
117.34
KB
-rwxr-xr-x
2016-12-13 13:06
groups
34.79
KB
-rwxr-xr-x
2017-02-22 12:23
grub-editenv
236.97
KB
-rwxr-xr-x
2019-06-12 11:20
grub-file
660.64
KB
-rwxr-xr-x
2019-06-12 11:20
grub-fstest
786.75
KB
-rwxr-xr-x
2019-06-12 11:20
grub-glue-efi
232.81
KB
-rwxr-xr-x
2019-06-12 11:20
grub-kbdcomp
1.64
KB
-rwxr-xr-x
2019-06-12 11:20
grub-menulst2cfg
216.83
KB
-rwxr-xr-x
2019-06-12 11:20
grub-mkfont
261.47
KB
-rwxr-xr-x
2019-06-12 11:20
grub-mkimage
325.88
KB
-rwxr-xr-x
2019-06-12 11:20
grub-mklayout
241.09
KB
-rwxr-xr-x
2019-06-12 11:20
grub-mknetdir
366.55
KB
-rwxr-xr-x
2019-06-12 11:20
grub-mkpasswd-pbkdf2
241.16
KB
-rwxr-xr-x
2019-06-12 11:20
grub-mkrelpath
232.5
KB
-rwxr-xr-x
2019-06-12 11:20
grub-mkrescue
819.39
KB
-rwxr-xr-x
2019-06-12 11:20
grub-mkstandalone
442.88
KB
-rwxr-xr-x
2019-06-12 11:20
grub-mount
605.28
KB
-rwxr-xr-x
2019-06-12 11:20
grub-ntldr-img
34.45
KB
-rwxr-xr-x
2019-06-12 11:20
grub-render-label
673.23
KB
-rwxr-xr-x
2019-06-12 11:20
grub-script-check
260.63
KB
-rwxr-xr-x
2019-06-12 11:20
grub-syslinux2cfg
621.75
KB
-rwxr-xr-x
2019-06-12 11:20
gs
10.24
KB
-rwxr-xr-x
2020-08-20 14:04
gsbj
350
B
-rwxr-xr-x
2020-08-20 14:04
gsdj
352
B
-rwxr-xr-x
2020-08-20 14:04
gsdj500
352
B
-rwxr-xr-x
2020-08-20 14:04
gslj
353
B
-rwxr-xr-x
2020-08-20 14:04
gslp
350
B
-rwxr-xr-x
2020-08-20 14:04
gsnd
277
B
-rwxr-xr-x
2020-08-20 14:04
gtbl
118.2
KB
-rwxr-xr-x
2016-12-13 13:06
h2ph
28.52
KB
-rwxr-xr-x
2020-06-20 17:33
h2xs
59.39
KB
-rwxr-xr-x
2020-06-20 17:33
hd
26.61
KB
-rwxr-xr-x
2017-04-12 11:22
head
42.82
KB
-rwxr-xr-x
2017-02-22 12:23
helpztags
2.46
KB
-rwxr-xr-x
2019-06-21 04:10
hexdump
26.61
KB
-rwxr-xr-x
2017-04-12 11:22
host
114.45
KB
-rwxr-xr-x
2020-08-26 18:03
hostid
30.73
KB
-rwxr-xr-x
2017-02-22 12:23
hostnamectl
18.34
KB
-rwxr-xr-x
2019-07-21 18:43
htcacheclean
30
KB
-rwxr-xr-x
2019-10-13 15:43
htdbm
17.99
KB
-rwxr-xr-x
2019-10-13 15:43
htdigest
9.99
KB
-rwxr-xr-x
2019-10-13 15:43
htpasswd
17.99
KB
-rwxr-xr-x
2019-10-13 15:43
i386
18.73
KB
-rwxr-xr-x
2018-03-07 18:29
icombine
34.38
KB
-rwxr-xr-x
2016-03-04 07:59
iconv
55.01
KB
-rwxr-xr-x
2019-02-06 21:17
id
42.91
KB
-rwxr-xr-x
2017-02-22 12:23
igawk
3.11
KB
-rwxr-xr-x
2017-01-25 16:06
ijoin
14.1
KB
-rwxr-xr-x
2016-03-04 07:59
infocmp
58.07
KB
-rwxr-xr-x
2017-12-28 09:47
infotocap
78.11
KB
-rwxr-xr-x
2017-12-28 09:47
innochecksum
3.42
MB
-rwxr-xr-x
2021-01-31 16:38
innotop
445.81
KB
-rwxr-xr-x
2020-10-12 17:40
install
135.61
KB
-rwxr-xr-x
2017-02-22 12:23
instmodsh
4.27
KB
-rwxr-xr-x
2020-06-20 17:33
ionice
26.66
KB
-rwxr-xr-x
2018-03-07 18:29
iostat
42.13
KB
-rwxr-xr-x
2017-05-25 20:26
ipcmk
26.77
KB
-rwxr-xr-x
2018-03-07 18:29
ipcrm
26.63
KB
-rwxr-xr-x
2018-03-07 18:29
ipcs
50.79
KB
-rwxr-xr-x
2018-03-07 18:29
iptables-xml
92.74
KB
-rwxr-xr-x
2017-04-12 09:41
ischroot
10.3
KB
-rwxr-xr-x
2017-04-02 17:10
ispell
94.46
KB
-rwxr-xr-x
2016-03-04 07:59
ispell-wrapper
7.05
KB
-rwxr-xr-x
2016-10-10 09:58
join
46.85
KB
-rwxr-xr-x
2017-02-22 12:23
json_pp
3.86
KB
-rwxr-xr-x
2020-06-20 17:33
kbdinfo
10.38
KB
-rwxr-xr-x
2016-01-05 16:55
kbxutil
154.63
KB
-rwxr-xr-x
2019-02-07 20:57
kernel-install
3.91
KB
-rwxr-xr-x
2019-07-21 18:43
killall
23.68
KB
-rwxr-xr-x
2015-08-17 13:18
last
42.85
KB
-rwxr-xr-x
2018-03-07 18:29
lastb
42.85
KB
-rwxr-xr-x
2018-03-07 18:29
lastlog
18.07
KB
-rwxr-xr-x
2017-05-17 11:59
lcf
7.6
KB
-rwxr-xr-x
2016-03-16 20:58
ldd
5.27
KB
-rwxr-xr-x
2019-02-06 21:17
less
161.82
KB
-rwxr-xr-x
2016-02-28 11:28
lessecho
10.02
KB
-rwxr-xr-x
2016-02-28 11:28
lessfile
7.58
KB
-rwxr-xr-x
2016-02-28 11:28
lesskey
19.36
KB
-rwxr-xr-x
2016-02-28 11:28
lesspipe
7.58
KB
-rwxr-xr-x
2016-02-28 11:28
letsencrypt
385
B
-rwxr-xr-x
2020-09-26 18:25
lexgrog
90.57
KB
-rwxr-xr-x
2016-12-13 13:10
lft
2.43
KB
-rwxr-xr-x
2016-08-29 15:45
lft.db
2.43
KB
-rwxr-xr-x
2016-08-29 15:45
libnetcfg
15.39
KB
-rwxr-xr-x
2020-06-20 17:33
line
10.4
KB
-rwxr-xr-x
2018-03-07 18:29
link
30.73
KB
-rwxr-xr-x
2017-02-22 12:23
linux-boot-prober
1.54
KB
-rwxr-xr-x
2017-01-20 15:28
linux-check-removal
3.99
KB
-rwxr-xr-x
2016-06-21 02:48
linux-update-symlinks
6.17
KB
-rwxr-xr-x
2016-06-05 01:13
linux-version
2.63
KB
-rwxr-xr-x
2015-08-11 15:45
linux32
18.73
KB
-rwxr-xr-x
2018-03-07 18:29
linux64
18.73
KB
-rwxr-xr-x
2018-03-07 18:29
lnstat
18.8
KB
-rwxr-xr-x
2017-11-24 09:22
loadkeys
199.46
KB
-rwxr-xr-x
2016-01-05 16:55
loadunimap
26.68
KB
-rwxr-xr-x
2016-01-05 16:55
locale
37.91
KB
-rwxr-xr-x
2019-02-06 21:17
localectl
26.41
KB
-rwxr-xr-x
2019-07-21 18:43
localedef
295.69
KB
-rwxr-xr-x
2019-02-06 21:17
logger
43.43
KB
-rwxr-xr-x
2018-03-07 18:29
logname
30.73
KB
-rwxr-xr-x
2017-02-22 12:23
logresolve
10
KB
-rwxr-xr-x
2019-10-13 15:43
look
10.33
KB
-rwxr-xr-x
2017-04-12 11:22
lorder
2.78
KB
-rwxr-xr-x
2017-04-12 11:22
lsattr
10
KB
-rwxr-xr-x
2020-07-25 09:03
lsb_release
3.55
KB
-rwxr-xr-x
2015-08-26 09:44
lscpu
63.2
KB
-rwxr-xr-x
2018-03-07 18:29
lsinitramfs
625
B
-rwxr-xr-x
2017-03-06 22:42
lsipc
71.12
KB
-rwxr-xr-x
2018-03-07 18:29
lslocks
35.16
KB
-rwxr-xr-x
2018-03-07 18:29
lslogins
59.27
KB
-rwxr-xr-x
2018-03-07 18:29
lsns
38.87
KB
-rwxr-xr-x
2018-03-07 18:29
lsof
159.31
KB
-rwxr-xr-x
2015-09-13 21:46
lspci
80.31
KB
-rwxr-xr-x
2016-11-30 06:53
lspgpot
1.06
KB
-rwxr-xr-x
2014-06-25 16:17
lzcat
75.38
KB
-rwxr-xr-x
2016-10-08 13:11
lzcmp
6.48
KB
-rwxr-xr-x
2016-10-08 13:11
lzdiff
6.48
KB
-rwxr-xr-x
2016-10-08 13:11
lzegrep
5.5
KB
-rwxr-xr-x
2016-10-08 13:11
lzfgrep
5.5
KB
-rwxr-xr-x
2016-10-08 13:11
lzgrep
5.5
KB
-rwxr-xr-x
2016-10-08 13:11
lzless
1.76
KB
-rwxr-xr-x
2016-10-08 13:11
lzma
75.38
KB
-rwxr-xr-x
2016-10-08 13:11
lzmainfo
10.38
KB
-rwxr-xr-x
2016-10-08 13:11
lzmore
2.11
KB
-rwxr-xr-x
2016-10-08 13:11
man
104.5
KB
-rwxr-xr-x
2016-12-13 13:10
mandb
126.72
KB
-rwxr-xr-x
2016-12-13 13:10
manpath
30.47
KB
-rwxr-xr-x
2016-12-13 13:10
mapscrn
18.65
KB
-rwxr-xr-x
2016-01-05 16:55
mariabackup
17.34
MB
-rwxr-xr-x
2021-01-31 16:38
mariadb
4.12
MB
-rwxr-xr-x
2021-01-31 16:38
mariadb-service-convert
2.43
KB
-rwxr-xr-x
2021-01-31 16:38
mariadbcheck
3.91
MB
-rwxr-xr-x
2021-01-31 16:38
mawk
119.12
KB
-rwxr-xr-x
2012-03-23 20:15
mbstream
3.4
MB
-rwxr-xr-x
2021-01-31 16:38
mcookie
30.79
KB
-rwxr-xr-x
2018-03-07 18:29
md5sum
42.85
KB
-rwxr-xr-x
2017-02-22 12:23
md5sum.textutils
42.85
KB
-rwxr-xr-x
2017-02-22 12:23
mesg
10.45
KB
-rwxr-xr-x
2018-03-07 18:29
migrate-pubring-from-classic-gpg
2.14
KB
-rwxr-xr-x
2018-10-03 00:58
mk_modmap
15.78
KB
-rwxr-xr-x
2016-01-05 16:55
mkfifo
63.04
KB
-rwxr-xr-x
2017-02-22 12:23
mkpasswd
18.57
KB
-rwxr-xr-x
2017-07-27 15:45
mpstat
38.15
KB
-rwxr-xr-x
2017-05-25 20:26
msql2mysql
1.41
KB
-rwxr-xr-x
2021-01-31 16:38
mtr
84.72
KB
-rwsr-xr-x
2017-01-02 18:20
munchlist
31.23
KB
-rwxr-xr-x
2016-03-04 07:59
my_print_defaults
3.39
MB
-rwxr-xr-x
2021-01-31 16:38
myisam_ftdump
3.75
MB
-rwxr-xr-x
2021-01-31 16:38
myisamchk
3.87
MB
-rwxr-xr-x
2021-01-31 16:38
myisamlog
3.73
MB
-rwxr-xr-x
2021-01-31 16:38
myisampack
3.77
MB
-rwxr-xr-x
2021-01-31 16:38
mysql
4.12
MB
-rwxr-xr-x
2021-01-31 16:38
mysql_convert_table_format
4.12
KB
-rwxr-xr-x
2021-01-31 16:38
mysql_embedded
16.03
MB
-rwxr-xr-x
2021-01-31 16:38
mysql_find_rows
3.21
KB
-rwxr-xr-x
2021-01-31 16:38
mysql_fix_extensions
1.22
KB
-rwxr-xr-x
2021-01-31 16:38
mysql_install_db
19.15
KB
-rwxr-xr-x
2021-01-31 16:38
mysql_plugin
3.39
MB
-rwxr-xr-x
2021-01-31 16:38
mysql_secure_installation
12.23
KB
-rwxr-xr-x
2021-01-31 16:38
mysql_setpermission
17.07
KB
-rwxr-xr-x
2021-01-31 16:38
mysql_tzinfo_to_sql
3.39
MB
-rwxr-xr-x
2021-01-31 16:38
mysql_upgrade
3.47
MB
-rwxr-xr-x
2021-01-31 16:38
mysql_waitpid
3.38
MB
-rwxr-xr-x
2021-01-31 16:38
mysql_zap
3.77
KB
-rwxr-xr-x
2021-01-31 16:38
mysqlaccess
109.33
KB
-rwxr-xr-x
2021-01-31 16:38
mysqladmin
3.91
MB
-rwxr-xr-x
2021-01-31 16:38
mysqlanalyze
3.91
MB
-rwxr-xr-x
2021-01-31 16:38
mysqlbinlog
4.08
MB
-rwxr-xr-x
2021-01-31 16:38
mysqlcheck
3.91
MB
-rwxr-xr-x
2021-01-31 16:38
mysqld_multi
23.84
KB
-rwxr-xr-x
2021-01-31 16:38
mysqld_safe
30.79
KB
-rwxr-xr-x
2021-01-31 16:38
mysqld_safe_helper
3.35
MB
-rwxr-xr-x
2021-01-31 16:38
mysqldump
3.99
MB
-rwxr-xr-x
2021-01-31 16:38
mysqldumpslow
8.05
KB
-rwxr-xr-x
2021-01-31 16:38
mysqlhotcopy
34.12
KB
-rwxr-xr-x
2021-01-31 16:38
mysqlimport
3.9
MB
-rwxr-xr-x
2021-01-31 16:38
mysqloptimize
3.91
MB
-rwxr-xr-x
2021-01-31 16:38
mysqlrepair
3.91
MB
-rwxr-xr-x
2021-01-31 16:38
mysqlreport
50.03
KB
-rwxr-xr-x
2020-10-12 17:40
mysqlshow
3.9
MB
-rwxr-xr-x
2021-01-31 16:38
mysqlslap
3.92
MB
-rwxr-xr-x
2021-01-31 16:38
mytop
63.3
KB
-rwxr-xr-x
2021-01-31 16:38
namei
26.66
KB
-rwxr-xr-x
2018-03-07 18:29
nawk
646.72
KB
-rwxr-xr-x
2017-01-25 16:06
ncal
29.21
KB
-rwxr-xr-x
2017-04-12 11:22
neqn
908
B
-rwxr-xr-x
2016-12-13 13:06
newgrp
39.37
KB
-rwsr-xr-x
2017-05-17 11:59
ngettext
34.7
KB
-rwxr-xr-x
2019-08-30 23:30
nice
34.76
KB
-rwxr-xr-x
2017-02-22 12:23
nl
38.91
KB
-rwxr-xr-x
2017-02-22 12:23
nohup
34.79
KB
-rwxr-xr-x
2017-02-22 12:23
nproc
34.79
KB
-rwxr-xr-x
2017-02-22 12:23
nroff
3.25
KB
-rwxr-xr-x
2016-12-13 13:06
nsenter
30.95
KB
-rwxr-xr-x
2018-03-07 18:29
nstat
22.67
KB
-rwxr-xr-x
2017-11-24 09:22
numfmt
58.91
KB
-rwxr-xr-x
2017-02-22 12:23
od
66.91
KB
-rwxr-xr-x
2017-02-22 12:23
on_ac_power
2.2
KB
-rwxr-xr-x
2009-12-02 08:57
openssl
639.48
KB
-rwxr-xr-x
2020-12-11 09:22
os-prober
4.44
KB
-rwxr-xr-x
2017-01-31 03:56
pager
161.82
KB
-rwxr-xr-x
2016-02-28 11:28
paperconf
10.34
KB
-rwxr-xr-x
2016-11-11 11:28
partx
83.63
KB
-rwxr-xr-x
2018-03-07 18:29
passwd
58.28
KB
-rwsr-xr-x
2017-05-17 11:59
paste
34.79
KB
-rwxr-xr-x
2017-02-22 12:23
pasteurize
388
B
-rwxr-xr-x
2016-09-23 17:38
pathchk
30.76
KB
-rwxr-xr-x
2017-02-22 12:23
pbr
152
B
-rwxr-xr-x
2016-09-21 14:14
pcimodules
14.59
KB
-rwxr-xr-x
2016-11-30 06:53
pdb
45.02
KB
-rwxr-xr-x
2020-08-22 10:03
pdb2.7
45.02
KB
-rwxr-xr-x
2020-08-22 10:03
pdb3
59.7
KB
-rwxr-xr-x
2020-11-18 21:09
pdb3.5
59.7
KB
-rwxr-xr-x
2020-11-18 21:09
pdf2dsc
698
B
-rwxr-xr-x
2020-08-20 14:04
pdf2ps
909
B
-rwxr-xr-x
2020-08-20 14:04
peekfd
10.52
KB
-rwxr-xr-x
2015-08-17 13:18
perf
528
B
-rwxr-xr-x
2016-09-16 23:34
perl
1.93
MB
-rwxr-xr-x
2020-06-20 17:33
perl5.24-x86_64-linux-gnu
10.24
KB
-rwxr-xr-x
2020-06-20 17:33
perl5.24.1
1.93
MB
-rwxr-xr-x
2020-06-20 17:33
perlbug
44.46
KB
-rwxr-xr-x
2020-06-20 17:33
perldoc
125
B
-rwxr-xr-x
2020-06-20 17:33
perlivp
10.61
KB
-rwxr-xr-x
2020-06-20 17:33
perlthanks
44.46
KB
-rwxr-xr-x
2020-06-20 17:33
perror
3.54
MB
-rwxr-xr-x
2021-01-31 16:38
pf2afm
498
B
-rwxr-xr-x
2020-08-20 14:04
pfbtopfa
516
B
-rwxr-xr-x
2020-08-20 14:04
pg
38.89
KB
-rwxr-xr-x
2018-03-07 18:29
pgrep
26.09
KB
-rwxr-xr-x
2018-05-17 10:56
phar
14.54
KB
-rwxr-xr-x
2021-02-12 14:49
phar.phar
14.54
KB
-rwxr-xr-x
2021-02-12 14:49
phar.phar7.0
14.48
KB
-rwxr-xr-x
2020-10-06 17:08
phar.phar7.4
14.54
KB
-rwxr-xr-x
2021-02-12 14:49
phar7.0
14.48
KB
-rwxr-xr-x
2020-10-06 17:08
phar7.4
14.54
KB
-rwxr-xr-x
2021-02-12 14:49
phar7.4.phar
14.54
KB
-rwxr-xr-x
2021-02-12 14:49
php
4.46
MB
-rwxr-xr-x
2021-02-12 14:49
php7.0
4.19
MB
-rwxr-xr-x
2020-10-06 17:08
php7.4
4.46
MB
-rwxr-xr-x
2021-02-12 14:49
pic
196.03
KB
-rwxr-xr-x
2016-12-13 13:06
pico
220.04
KB
-rwxr-xr-x
2017-01-11 02:10
piconv
8.16
KB
-rwxr-xr-x
2020-06-20 17:33
pidstat
54.15
KB
-rwxr-xr-x
2017-05-25 20:26
pinentry
54.46
KB
-rwxr-xr-x
2017-02-06 08:56
pinentry-curses
54.46
KB
-rwxr-xr-x
2017-02-06 08:56
pinky
38.95
KB
-rwxr-xr-x
2017-02-22 12:23
pkill
26.09
KB
-rwxr-xr-x
2018-05-17 10:56
pl2pm
4.42
KB
-rwxr-xr-x
2020-06-20 17:33
pldd
14.57
KB
-rwxr-xr-x
2019-02-06 21:17
pmap
30.09
KB
-rwxr-xr-x
2018-05-17 10:56
pod2html
4.04
KB
-rwxr-xr-x
2020-06-20 17:33
pod2man
13.84
KB
-rwxr-xr-x
2020-06-20 17:33
pod2text
10.72
KB
-rwxr-xr-x
2020-06-20 17:33
pod2usage
3.86
KB
-rwxr-xr-x
2020-06-20 17:33
podchecker
3.61
KB
-rwxr-xr-x
2020-06-20 17:33
podselect
2.47
KB
-rwxr-xr-x
2020-06-20 17:33
pphs
404
B
-rwxr-xr-x
2020-08-20 14:04
pr
75.01
KB
-rwxr-xr-x
2017-02-22 12:23
preconv
42.2
KB
-rwxr-xr-x
2016-12-13 13:06
prename
3.13
KB
-rwxr-xr-x
2020-06-20 17:33
print
17.74
KB
-rwxr-xr-x
2016-05-01 11:20
printafm
395
B
-rwxr-xr-x
2020-08-20 14:04
printenv
30.73
KB
-rwxr-xr-x
2017-02-22 12:23
printerbanner
18.28
KB
-rwxr-xr-x
2017-04-12 11:22
printf
50.79
KB
-rwxr-xr-x
2017-02-22 12:23
prlimit
31.38
KB
-rwxr-xr-x
2018-03-07 18:29
procan
71.74
KB
-rwxr-xr-x
2017-07-14 13:52
prove
13.27
KB
-rwxr-xr-x
2020-06-20 17:33
prtstat
14.42
KB
-rwxr-xr-x
2015-08-17 13:18
ps2ascii
631
B
-rwxr-xr-x
2020-08-20 14:04
ps2epsi
2.69
KB
-rwxr-xr-x
2020-08-20 14:04
ps2pdf
272
B
-rwxr-xr-x
2020-08-20 14:04
ps2pdf12
215
B
-rwxr-xr-x
2020-08-20 14:04
ps2pdf13
215
B
-rwxr-xr-x
2020-08-20 14:04
ps2pdf14
215
B
-rwxr-xr-x
2020-08-20 14:04
ps2pdfwr
1.07
KB
-rwxr-xr-x
2020-08-20 14:04
ps2ps
647
B
-rwxr-xr-x
2020-08-20 14:04
ps2ps2
669
B
-rwxr-xr-x
2020-08-20 14:04
ps2txt
631
B
-rwxr-xr-x
2020-08-20 14:04
psfaddtable
18.38
KB
-rwxr-xr-x
2016-01-05 16:55
psfgettable
18.38
KB
-rwxr-xr-x
2016-01-05 16:55
psfstriptable
18.38
KB
-rwxr-xr-x
2016-01-05 16:55
psfxtable
18.38
KB
-rwxr-xr-x
2016-01-05 16:55
pstree
27.49
KB
-rwxr-xr-x
2015-08-17 13:18
pstree.x11
27.49
KB
-rwxr-xr-x
2015-08-17 13:18
pstruct
35.89
KB
-rwxr-xr-x
2020-06-20 17:33
ptar
3.48
KB
-rwxr-xr-x
2020-06-20 17:33
ptardiff
2.57
KB
-rwxr-xr-x
2020-06-20 17:33
ptargrep
4.29
KB
-rwxr-xr-x
2020-06-20 17:33
ptx
71.01
KB
-rwxr-xr-x
2017-02-22 12:23
pwdx
10.07
KB
-rwxr-xr-x
2018-05-17 10:56
py3clean
7.62
KB
-rwxr-xr-x
2017-01-20 10:03
py3compile
11.83
KB
-rwxr-xr-x
2017-01-20 10:03
py3versions
11.44
KB
-rwxr-xr-x
2017-01-20 10:03
pybuild
21.75
KB
-rwxr-xr-x
2017-01-25 14:47
pyclean
4.03
KB
-rwxr-xr-x
2017-01-24 13:00
pycompile
11.62
KB
-rwxr-xr-x
2017-01-24 13:00
pydoc
79
B
-rwxr-xr-x
2020-08-22 10:03
pydoc2.7
79
B
-rwxr-xr-x
2020-08-22 10:03
pydoc3
79
B
-rwxr-xr-x
2020-11-18 21:09
pydoc3.5
79
B
-rwxr-xr-x
2020-11-18 21:09
pygettext
21.58
KB
-rwxr-xr-x
2020-08-22 10:03
pygettext2.7
21.58
KB
-rwxr-xr-x
2020-08-22 10:03
pygettext3
21.73
KB
-rwxr-xr-x
2020-11-18 21:09
pygettext3.5
21.73
KB
-rwxr-xr-x
2020-11-18 21:09
python
3.62
MB
-rwxr-xr-x
2020-08-22 10:03
python2
3.62
MB
-rwxr-xr-x
2020-08-22 10:03
python2.7
3.62
MB
-rwxr-xr-x
2020-08-22 10:03
python3
4.54
MB
-rwxr-xr-x
2020-11-18 21:09
python3-futurize
384
B
-rwxr-xr-x
2016-09-23 17:38
python3-pasteurize
388
B
-rwxr-xr-x
2016-09-23 17:38
python3-pbr
152
B
-rwxr-xr-x
2016-09-21 14:14
python3.5
4.54
MB
-rwxr-xr-x
2020-11-18 21:09
python3.5m
4.54
MB
-rwxr-xr-x
2020-11-18 21:09
python3m
4.54
MB
-rwxr-xr-x
2020-11-18 21:09
pyversions
14.75
KB
-rwxr-xr-x
2017-01-24 13:00
querybts
10.59
KB
-rwxr-xr-x
2019-08-29 14:19
rcp
86.14
KB
-rwxr-xr-x
2019-07-15 13:32
realpath
46.82
KB
-rwxr-xr-x
2017-02-22 12:23
rename
3.1
KB
-rwxr-xr-x
2015-06-04 22:55
rename.ul
14.48
KB
-rwxr-xr-x
2018-03-07 18:29
renice
10.36
KB
-rwxr-xr-x
2018-03-07 18:29
replace
3.36
MB
-rwxr-xr-x
2021-01-31 16:38
report-hw
2.05
KB
-rwxr-xr-x
2015-12-30 04:01
reportbug
103.63
KB
-rwxr-xr-x
2019-08-29 14:19
reset
22
KB
-rwxr-xr-x
2017-12-28 09:47
resizecons
18.65
KB
-rwxr-xr-x
2016-01-05 16:55
resizepart
38.86
KB
-rwxr-xr-x
2018-03-07 18:29
resolve_stack_dump
3.38
MB
-rwxr-xr-x
2021-01-31 16:38
resolveip
3.38
MB
-rwxr-xr-x
2021-01-31 16:38
rev
10.45
KB
-rwxr-xr-x
2018-03-07 18:29
rgrep
30
B
-rwxr-xr-x
2016-11-28 21:59
rlogin
714.86
KB
-rwxr-xr-x
2019-07-15 13:32
rotatelogs
18.07
KB
-rwxr-xr-x
2019-10-13 15:43
routef
173
B
-rwxr-xr-x
2017-11-24 09:22
routel
1.23
KB
-rwxr-xr-x
2017-11-24 09:22
rsh
714.86
KB
-rwxr-xr-x
2019-07-15 13:32
rsync
472.3
KB
-rwxr-xr-x
2019-03-15 10:39
rtstat
18.8
KB
-rwxr-xr-x
2017-11-24 09:22
run-mailcap
17.74
KB
-rwxr-xr-x
2016-05-01 11:20
runcon
34.85
KB
-rwxr-xr-x
2017-02-22 12:23
rview
2.3
MB
-rwxr-xr-x
2019-06-21 04:10
rvim
2.3
MB
-rwxr-xr-x
2019-06-21 04:10
sadf
282.37
KB
-rwxr-xr-x
2017-05-25 20:26
sar
109.7
KB
-rwxr-xr-x
2017-05-25 20:26
sar.sysstat
109.7
KB
-rwxr-xr-x
2017-05-25 20:26
savelog
10.22
KB
-rwxr-xr-x
2017-04-02 17:10
scp
86.14
KB
-rwxr-xr-x
2019-07-15 13:32
screendump
10.34
KB
-rwxr-xr-x
2016-01-05 16:55
script
22.73
KB
-rwxr-xr-x
2018-03-07 18:29
scriptreplay
22.63
KB
-rwxr-xr-x
2018-03-07 18:29
sdiff
50.85
KB
-rwxr-xr-x
2017-01-09 22:55
see
17.74
KB
-rwxr-xr-x
2016-05-01 11:20
select-default-iwrap
474
B
-rwxr-xr-x
2016-10-10 09:58
select-editor
1.19
KB
-rwxr-xr-x
2017-12-20 13:39
sensible-browser
1.11
KB
-rwxr-xr-x
2017-12-20 13:39
sensible-editor
1.08
KB
-rwxr-xr-x
2017-12-20 13:39
sensible-pager
288
B
-rwxr-xr-x
2017-12-20 13:39
seq
46.82
KB
-rwxr-xr-x
2017-02-22 12:23
setarch
18.73
KB
-rwxr-xr-x
2018-03-07 18:29
setkeycodes
10.37
KB
-rwxr-xr-x
2016-01-05 16:55
setleds
14.35
KB
-rwxr-xr-x
2016-01-05 16:55
setlogcons
10.37
KB
-rwxr-xr-x
2016-01-05 16:55
setmetamode
10.4
KB
-rwxr-xr-x
2016-01-05 16:55
setpci
22.54
KB
-rwxr-xr-x
2016-11-30 06:53
setsid
10.45
KB
-rwxr-xr-x
2018-03-07 18:29
setterm
38.68
KB
-rwxr-xr-x
2018-03-07 18:29
setvtrgb
10.46
KB
-rwxr-xr-x
2016-01-05 16:55
sftp
134.36
KB
-rwxr-xr-x
2019-07-15 13:32
sg
39.37
KB
-rwsr-xr-x
2017-05-17 11:59
sha1sum
46.85
KB
-rwxr-xr-x
2017-02-22 12:23
sha224sum
54.85
KB
-rwxr-xr-x
2017-02-22 12:23
sha256sum
54.85
KB
-rwxr-xr-x
2017-02-22 12:23
sha384sum
58.85
KB
-rwxr-xr-x
2017-02-22 12:23
sha512sum
58.85
KB
-rwxr-xr-x
2017-02-22 12:23
shasum
9.15
KB
-rwxr-xr-x
2020-06-20 17:33
showconsolefont
18.45
KB
-rwxr-xr-x
2016-01-05 16:55
showkey
14.63
KB
-rwxr-xr-x
2016-01-05 16:55
shred
59.01
KB
-rwxr-xr-x
2017-02-22 12:23
shuf
54.91
KB
-rwxr-xr-x
2017-02-22 12:23
skill
26.08
KB
-rwxr-xr-x
2018-05-17 10:56
slabtop
18.08
KB
-rwxr-xr-x
2018-05-17 10:56
slogin
714.86
KB
-rwxr-xr-x
2019-07-15 13:32
snice
26.08
KB
-rwxr-xr-x
2018-05-17 10:56
socat
369.47
KB
-rwxr-xr-x
2017-07-14 13:52
soelim
30.2
KB
-rwxr-xr-x
2016-12-13 13:06
sort
107.52
KB
-rwxr-xr-x
2017-02-22 12:23
splain
18.37
KB
-rwxr-xr-x
2020-06-20 17:33
split
55.38
KB
-rwxr-xr-x
2017-02-22 12:23
splitfont
10.25
KB
-rwxr-xr-x
2016-01-05 16:55
sq
5.99
KB
-rwxr-xr-x
2016-03-04 07:59
ssh
714.86
KB
-rwxr-xr-x
2019-07-15 13:32
ssh-add
330.21
KB
-rwxr-xr-x
2019-07-15 13:32
ssh-agent
350.22
KB
-rwxr-sr-x
2019-07-15 13:32
ssh-argv0
1.42
KB
-rwxr-xr-x
2019-03-01 16:19
ssh-copy-id
10.13
KB
-rwxr-xr-x
2016-12-19 04:59
ssh-keygen
390.23
KB
-rwxr-xr-x
2019-07-15 13:32
ssh-keyscan
406.23
KB
-rwxr-xr-x
2019-07-15 13:32
stat
83.1
KB
-rwxr-xr-x
2017-02-22 12:23
stdbuf
46.82
KB
-rwxr-xr-x
2017-02-22 12:23
sudo
137.64
KB
-rwsr-xr-x
2021-01-23 09:10
sudoedit
137.64
KB
-rwsr-xr-x
2021-01-23 09:10
sudoreplay
46.59
KB
-rwxr-xr-x
2021-01-23 09:10
sum
38.83
KB
-rwxr-xr-x
2017-02-22 12:23
symcryptrun
110.6
KB
-rwxr-xr-x
2019-02-07 20:57
systemd-analyze
1010.6
KB
-rwxr-xr-x
2019-07-21 18:43
systemd-cat
10.34
KB
-rwxr-xr-x
2019-07-21 18:43
systemd-cgls
14.34
KB
-rwxr-xr-x
2019-07-21 18:43
systemd-cgtop
30.44
KB
-rwxr-xr-x
2019-07-21 18:43
systemd-delta
22.41
KB
-rwxr-xr-x
2019-07-21 18:43
systemd-detect-virt
10.33
KB
-rwxr-xr-x
2019-07-21 18:43
systemd-mount
30.35
KB
-rwxr-xr-x
2019-07-21 18:43
systemd-path
10.33
KB
-rwxr-xr-x
2019-07-21 18:43
systemd-resolve
78.34
KB
-rwxr-xr-x
2019-07-21 18:43
systemd-run
38.34
KB
-rwxr-xr-x
2019-07-21 18:43
systemd-socket-activate
22.34
KB
-rwxr-xr-x
2019-07-21 18:43
systemd-stdio-bridge
14.34
KB
-rwxr-xr-x
2019-07-21 18:43
tabs
13.99
KB
-rwxr-xr-x
2017-12-28 09:47
tac
38.82
KB
-rwxr-xr-x
2017-02-22 12:23
tail
66.98
KB
-rwxr-xr-x
2017-02-22 12:23
tapestat
34.13
KB
-rwxr-xr-x
2017-05-25 20:26
tasksel
16.1
KB
-rwxr-xr-x
2016-12-24 12:46
taskset
30.75
KB
-rwxr-xr-x
2018-03-07 18:29
tbl
118.2
KB
-rwxr-xr-x
2016-12-13 13:06
tee
34.82
KB
-rwxr-xr-x
2017-02-22 12:23
telnet
104.42
KB
-rwxr-xr-x
2016-11-07 18:06
telnet.netkit
104.42
KB
-rwxr-xr-x
2016-11-07 18:06
test
46.79
KB
-rwxr-xr-x
2017-02-22 12:23
tic
78.11
KB
-rwxr-xr-x
2017-12-28 09:47
timedatectl
22.34
KB
-rwxr-xr-x
2019-07-21 18:43
timeout
39.35
KB
-rwxr-xr-x
2017-02-22 12:23
tload
14.09
KB
-rwxr-xr-x
2018-05-17 10:56
toe
13.99
KB
-rwxr-xr-x
2017-12-28 09:47
top
105.77
KB
-rwxr-xr-x
2018-05-17 10:56
touch
90.98
KB
-rwxr-xr-x
2017-02-22 12:23
tput
18.02
KB
-rwxr-xr-x
2017-12-28 09:47
tr
46.79
KB
-rwxr-xr-x
2017-02-22 12:23
traceproto
2.82
KB
-rwxr-xr-x
2016-08-29 15:45
traceproto.db
2.82
KB
-rwxr-xr-x
2016-08-29 15:45
traceroute
67.16
KB
-rwxr-xr-x
2016-08-29 15:45
traceroute-nanog
1.58
KB
-rwxr-xr-x
2016-08-29 15:45
traceroute.db
67.16
KB
-rwxr-xr-x
2016-08-29 15:45
traceroute6
67.16
KB
-rwxr-xr-x
2016-08-29 15:45
traceroute6.db
67.16
KB
-rwxr-xr-x
2016-08-29 15:45
troff
695.34
KB
-rwxr-xr-x
2016-12-13 13:06
truncate
38.76
KB
-rwxr-xr-x
2017-02-22 12:23
tryaffix
4.8
KB
-rwxr-xr-x
2016-03-04 07:59
tset
22
KB
-rwxr-xr-x
2017-12-28 09:47
tsort
34.76
KB
-rwxr-xr-x
2017-02-22 12:23
tty
30.76
KB
-rwxr-xr-x
2017-02-22 12:23
tzselect
14.83
KB
-rwxr-xr-x
2019-02-06 21:17
ucf
39.68
KB
-rwxr-xr-x
2016-03-16 20:58
ucfq
18.91
KB
-rwxr-xr-x
2016-03-16 20:58
ucfr
10.47
KB
-rwxr-xr-x
2016-03-16 20:58
ul
14.34
KB
-rwxr-xr-x
2017-04-12 11:22
unexpand
34.82
KB
-rwxr-xr-x
2017-02-22 12:23
unicode_stop
530
B
-rwxr-xr-x
2016-01-05 16:55
uniq
42.85
KB
-rwxr-xr-x
2017-02-22 12:23
unlink
30.73
KB
-rwxr-xr-x
2017-02-22 12:23
unlzma
75.38
KB
-rwxr-xr-x
2016-10-08 13:11
unmkinitramfs
2.79
KB
-rwxr-xr-x
2017-03-06 22:42
unshare
18.82
KB
-rwxr-xr-x
2018-03-07 18:29
unsq
9.99
KB
-rwxr-xr-x
2016-03-04 07:59
unxz
75.38
KB
-rwxr-xr-x
2016-10-08 13:11
update-alternatives
46.01
KB
-rwxr-xr-x
2018-06-26 10:28
update-mime-database
672
B
-rwxr-xr-x
2018-03-14 18:01
update-mime-database.real
51.23
KB
-rwxr-xr-x
2018-03-14 18:01
uptime
10.07
KB
-rwxr-xr-x
2018-05-17 10:56
users
30.79
KB
-rwxr-xr-x
2017-02-22 12:23
utmpdump
22.71
KB
-rwxr-xr-x
2018-03-07 18:29
vi
2.3
MB
-rwxr-xr-x
2019-06-21 04:10
view
2.3
MB
-rwxr-xr-x
2019-06-21 04:10
vim
2.3
MB
-rwxr-xr-x
2019-06-21 04:10
vim.basic
2.3
MB
-rwxr-xr-x
2019-06-21 04:10
vim.tiny
1.01
MB
-rwxr-xr-x
2019-06-21 04:10
vimdiff
2.3
MB
-rwxr-xr-x
2019-06-21 04:10
vimtutor
2.05
KB
-rwxr-xr-x
2019-06-21 04:10
vmstat
30.09
KB
-rwxr-xr-x
2018-05-17 10:56
w
18.07
KB
-rwxr-xr-x
2018-05-17 10:56
w.procps
18.07
KB
-rwxr-xr-x
2018-05-17 10:56
wall
26.8
KB
-rwxr-sr-x
2018-03-07 18:29
watch
22.41
KB
-rwxr-xr-x
2018-05-17 10:56
watchgnupg
13.99
KB
-rwxr-xr-x
2019-02-07 20:57
wc
42.86
KB
-rwxr-xr-x
2017-02-22 12:23
wget
479.56
KB
-rwxr-xr-x
2019-04-05 13:05
whatis
46.98
KB
-rwxr-xr-x
2016-12-13 13:10
whereis
27.09
KB
-rwxr-xr-x
2018-03-07 18:29
which
946
B
-rwxr-xr-x
2017-04-02 17:10
whiptail
26.77
KB
-rwxr-xr-x
2016-10-15 08:00
who
50.95
KB
-rwxr-xr-x
2017-02-22 12:23
whoami
30.76
KB
-rwxr-xr-x
2017-02-22 12:23
whois
149.18
KB
-rwxr-xr-x
2017-07-27 15:45
write
14.42
KB
-rwxr-sr-x
2017-04-12 11:22
wsrep_sst_common
10.51
KB
-rwxr-xr-x
2021-01-31 16:38
wsrep_sst_mariabackup
36.97
KB
-rwxr-xr-x
2021-01-31 16:38
wsrep_sst_mysqldump
7.69
KB
-rwxr-xr-x
2021-01-31 16:38
wsrep_sst_rsync
14.96
KB
-rwxr-xr-x
2021-01-31 16:38
wsrep_sst_rsync_wan
14.96
KB
-rwxr-xr-x
2021-01-31 16:38
wsrep_sst_xtrabackup
20.77
KB
-rwxr-xr-x
2021-01-31 16:38
wsrep_sst_xtrabackup-v2
40.73
KB
-rwxr-xr-x
2021-01-31 16:38
x86_64
18.73
KB
-rwxr-xr-x
2018-03-07 18:29
xargs
66.21
KB
-rwxr-xr-x
2017-02-18 15:37
xauth
47.47
KB
-rwxr-xr-x
2014-07-13 08:34
xdg-user-dir
234
B
-rwxr-xr-x
2014-09-19 09:17
xdg-user-dirs-update
18.59
KB
-rwxr-xr-x
2014-09-19 09:17
xsubpp
5.04
KB
-rwxr-xr-x
2020-06-20 17:33
xxd
18.12
KB
-rwxr-xr-x
2019-06-21 04:10
xz
75.38
KB
-rwxr-xr-x
2016-10-08 13:11
xzcat
75.38
KB
-rwxr-xr-x
2016-10-08 13:11
xzcmp
6.48
KB
-rwxr-xr-x
2016-10-08 13:11
xzdiff
6.48
KB
-rwxr-xr-x
2016-10-08 13:11
xzegrep
5.5
KB
-rwxr-xr-x
2016-10-08 13:11
xzfgrep
5.5
KB
-rwxr-xr-x
2016-10-08 13:11
xzgrep
5.5
KB
-rwxr-xr-x
2016-10-08 13:11
xzless
1.76
KB
-rwxr-xr-x
2016-10-08 13:11
xzmore
2.11
KB
-rwxr-xr-x
2016-10-08 13:11
yes
30.73
KB
-rwxr-xr-x
2017-02-22 12:23
zdump
14.42
KB
-rwxr-xr-x
2019-02-06 21:17
zipdetails
47.36
KB
-rwxr-xr-x
2020-06-20 17:33
Save
Rename
#!/bin/sh set -e unset GREP_OPTIONS GPGHOMEDIR CURRENTTRAP export IFS="$(printf "\n\b")" MASTER_KEYRING='' eval "$(apt-config shell MASTER_KEYRING APT::Key::MasterKeyring)" ARCHIVE_KEYRING='' eval "$(apt-config shell ARCHIVE_KEYRING APT::Key::ArchiveKeyring)" REMOVED_KEYS='' eval "$(apt-config shell REMOVED_KEYS APT::Key::RemovedKeys)" ARCHIVE_KEYRING_URI='' eval "$(apt-config shell ARCHIVE_KEYRING_URI APT::Key::ArchiveKeyringURI)" aptkey_echo() { echo "$@"; } requires_root() { if [ "$(id -u)" -ne 0 ]; then apt_error "This command can only be used by root." exit 1 fi } command_available() { if [ -x "$1" ]; then return 0; fi # command -v "$1" >/dev/null 2>&1 # not required by policy, see #747320 # which "$1" >/dev/null 2>&1 # is in debianutils (essential) but not on non-debian systems local OLDIFS="$IFS" IFS=: for p in $PATH; do if [ -x "${p}/${1}" ]; then IFS="$OLDIFS" return 0 fi done IFS="$OLDIFS" return 1 } escape_shell() { echo "$@" | sed -e "s#'#'\"'\"'#g" } get_fingerprints_of_keyring() { aptkey_execute "$GPG_SH" --keyring "$1" --with-colons --fingerprint | while read publine; do # search for a public key if [ "${publine%%:*}" != 'pub' ]; then continue; fi # search for the associated fingerprint (should be the very next line) while read fprline; do if [ "${fprline%%:*}" = 'sub' ]; then break; # should never happen elif [ "${fprline%%:*}" != 'fpr' ]; then continue; fi echo "$fprline" | cut -d':' -f 10 done # order in the keyring shouldn't be important done | sort } add_keys_with_verify_against_master_keyring() { ADD_KEYRING="$1" MASTER="$2" if [ ! -f "$ADD_KEYRING" ]; then apt_error "Keyring '$ADD_KEYRING' to be added not found" return fi if [ ! -f "$MASTER" ]; then apt_error "Master-Keyring '$MASTER' not found" return fi # when adding new keys, make sure that the archive-master-keyring # is honored. so: # all keys that are exported must have a valid signature # from a key in the $distro-master-keyring add_keys="$(get_fingerprints_of_keyring "$ADD_KEYRING")" all_add_keys="$(aptkey_execute "$GPG_SH" --keyring "$ADD_KEYRING" --with-colons --list-keys | grep ^[ps]ub | cut -d: -f5)" master_keys="$(aptkey_execute "$GPG_SH" --keyring "$MASTER" --with-colons --list-keys | grep ^pub | cut -d: -f5)" # ensure there are no colisions LP: #857472 for all_add_key in $all_add_keys; do for master_key in $master_keys; do if [ "$all_add_key" = "$master_key" ]; then echo >&2 "Keyid collision for '$all_add_key' detected, operation aborted" return 1 fi done done for add_key in $add_keys; do # export the add keyring one-by-one local TMP_KEYRING="${GPGHOMEDIR}/tmp-keyring.gpg" aptkey_execute "$GPG_SH" --batch --yes --keyring "$ADD_KEYRING" --output "$TMP_KEYRING" --export "$add_key" if ! aptkey_execute "$GPG_SH" --batch --yes --keyring "$TMP_KEYRING" --import "$MASTER" > "${GPGHOMEDIR}/gpgoutput.log" 2>&1; then cat >&2 "${GPGHOMEDIR}/gpgoutput.log" false fi # check if signed with the master key and only add in this case ADDED=0 for master_key in $master_keys; do if aptkey_execute "$GPG_SH" --keyring "$TMP_KEYRING" --check-sigs --with-colons "$add_key" \ | grep '^sig:!:' | cut -d: -f5 | grep -q "$master_key"; then aptkey_execute "$GPG_SH" --batch --yes --keyring "$ADD_KEYRING" --export "$add_key" \ | aptkey_execute "$GPG" --batch --yes --import ADDED=1 fi done if [ $ADDED = 0 ]; then echo >&2 "Key '$add_key' not added. It is not signed with a master key" fi rm -f "${TMP_KEYRING}" done } # update the current archive signing keyring from a network URI # the archive-keyring keys needs to be signed with the master key # (otherwise it does not make sense from a security POV) net_update() { local APT_DIR='/' eval $(apt-config shell APT_DIR Dir) # Disabled for now as code is insecure (LP: #1013639 (and 857472, 1013128)) APT_KEY_NET_UPDATE_ENABLED="" eval $(apt-config shell APT_KEY_NET_UPDATE_ENABLED APT::Key::Net-Update-Enabled) if [ -z "$APT_KEY_NET_UPDATE_ENABLED" ]; then exit 1 fi if [ -z "$ARCHIVE_KEYRING_URI" ]; then apt_error 'Your distribution is not supported in net-update as no uri for the archive-keyring is set' exit 1 fi # in theory we would need to depend on wget for this, but this feature # isn't useable in debian anyway as we have no keyring uri nor a master key if ! command_available 'wget'; then apt_error 'wget is required for a network-based update, but it is not installed' exit 1 fi if [ ! -d "${APT_DIR}/var/lib/apt/keyrings" ]; then mkdir -p "${APT_DIR}/var/lib/apt/keyrings" fi keyring="${APT_DIR}/var/lib/apt/keyrings/$(basename "$ARCHIVE_KEYRING_URI")" old_mtime=0 if [ -e $keyring ]; then old_mtime=$(stat -c %Y "$keyring") fi (cd "${APT_DIR}/var/lib/apt/keyrings"; wget --timeout=90 -q -N "$ARCHIVE_KEYRING_URI") if [ ! -e "$keyring" ]; then return fi new_mtime=$(stat -c %Y "$keyring") if [ $new_mtime -ne $old_mtime ]; then aptkey_echo "Checking for new archive signing keys now" add_keys_with_verify_against_master_keyring "$keyring" "$MASTER_KEYRING" fi } update() { if [ -z "$APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE" ]; then echo >&2 "Warning: 'apt-key update' is deprecated and should not be used anymore!" if [ -z "$ARCHIVE_KEYRING" ]; then echo >&2 "Note: In your distribution this command is a no-op and can therefore be removed safely." exit 0 fi fi if [ ! -f "$ARCHIVE_KEYRING" ]; then apt_error "Can't find the archive-keyring (Is the debian-archive-keyring package installed?)" exit 1 fi # add new keys from the package; # we do not use add_keys_with_verify_against_master_keyring here, # because "update" is run on regular package updates. A # attacker might as well replace the master-archive-keyring file # in the package and add his own keys. so this check wouldn't # add any security. we *need* this check on net-update though import_keyring_into_keyring "$ARCHIVE_KEYRING" '' && cat "${GPGHOMEDIR}/gpgoutput.log" if [ -r "$REMOVED_KEYS" ]; then # remove no-longer supported/used keys get_fingerprints_of_keyring "$(dearmor_filename "$REMOVED_KEYS")" | while read key; do foreach_keyring_do 'remove_key_from_keyring' "$key" done else apt_warn "Removed keys keyring '$REMOVED_KEYS' missing or not readable" fi } remove_key_from_keyring() { local KEYRINGFILE="$1" shift # non-existent keyrings have by definition no keys if [ ! -e "$KEYRINGFILE" ]; then return fi local FINGERPRINTS="${GPGHOMEDIR}/keyringfile.keylst" local DEARMOR="$(dearmor_filename "$KEYRINGFILE")" get_fingerprints_of_keyring "$DEARMOR" > "$FINGERPRINTS" for KEY in "$@"; do # strip leading 0x, if present: KEY="$(echo "${KEY#0x}" | tr -d ' ')" # check if the key is in this keyring if ! grep -iq "^[0-9A-F]*${KEY}$" "$FINGERPRINTS"; then continue fi if [ ! -w "$KEYRINGFILE" ]; then apt_warn "Key ${KEY} is in keyring ${KEYRINGFILE}, but can't be removed as it is read only." continue fi # check if it is the only key in the keyring and if so remove the keyring altogether if [ '1' = "$(uniq "$FINGERPRINTS" | wc -l)" ]; then mv -f "$KEYRINGFILE" "${KEYRINGFILE}~" # behave like gpg return fi # we can't just modify pointed to files as these might be in /usr or something local REALTARGET if [ -L "$DEARMOR" ]; then REALTARGET="$(readlink -f "$DEARMOR")" mv -f "$DEARMOR" "${DEARMOR}.dpkg-tmp" cp -a "$REALTARGET" "$DEARMOR" fi # delete the key from the keyring aptkey_execute "$GPG_SH" --keyring "$DEARMOR" --batch --delete-keys --yes "$KEY" if [ -n "$REALTARGET" ]; then # the real backup is the old link, not the copy we made mv -f "${DEARMOR}.dpkg-tmp" "${DEARMOR}~" fi if [ "$DEARMOR" != "$KEYRINGFILE" ]; then mv -f "$KEYRINGFILE" "${KEYRINGFILE}~" create_new_keyring "$KEYRINGFILE" aptkey_execute "$GPG_SH" --keyring "$DEARMOR" --armor --export > "$KEYRINGFILE" fi get_fingerprints_of_keyring "$DEARMOR" > "$FINGERPRINTS" done } accessible_file_exists() { if ! test -s "$1"; then return 1 fi if test -r "$1"; then return 0 fi apt_warn "The key(s) in the keyring $1 are ignored as the file is not readable by user '$USER' executing apt-key." return 1 } foreach_keyring_do() { local ACTION="$1" shift # if a --keyring was given, just work on this one if [ -n "$FORCED_KEYRING" ]; then $ACTION "$TRUSTEDFILE" "$@" else # otherwise all known keyrings are up for inspection if accessible_file_exists "$TRUSTEDFILE"; then $ACTION "$TRUSTEDFILE" "$@" fi local TRUSTEDPARTS="/etc/apt/trusted.gpg.d" eval "$(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)" if [ -d "$TRUSTEDPARTS" ]; then TRUSTEDPARTS="$(readlink -f "$TRUSTEDPARTS")" local TRUSTEDPARTSLIST="$(cd /; find "$TRUSTEDPARTS" -mindepth 1 -maxdepth 1 \( -name '*.gpg' -o -name '*.asc' \))" for trusted in $(echo "$TRUSTEDPARTSLIST" | sort); do if accessible_file_exists "$trusted"; then $ACTION "$trusted" "$@" fi done fi fi } list_keys_in_keyring() { local KEYRINGFILE="$1" shift # fingerprint and co will fail if key isn't in this keyring aptkey_execute "$GPG_SH" --keyring "$(dearmor_filename "$KEYRINGFILE")" "$@" > "${GPGHOMEDIR}/gpgoutput.log" 2> "${GPGHOMEDIR}/gpgoutput.err" || true if [ ! -s "${GPGHOMEDIR}/gpgoutput.log" ]; then return fi # we fake gpg header here to refer to the real asc file rather than a temp file if [ "${KEYRINGFILE##*.}" = 'asc' ]; then if expr match "$(sed -n '2p' "${GPGHOMEDIR}/gpgoutput.log")" '^-\+$' >/dev/null 2>&1; then echo "$KEYRINGFILE" echo "$KEYRINGFILE" | sed 's#[^-]#-#g' sed '1,2d' "${GPGHOMEDIR}/gpgoutput.log" || true else cat "${GPGHOMEDIR}/gpgoutput.log" fi else cat "${GPGHOMEDIR}/gpgoutput.log" fi if [ -s "${GPGHOMEDIR}/gpgoutput.err" ]; then cat >&2 "${GPGHOMEDIR}/gpgoutput.err" fi } export_key_from_to() { local FROM="$1" local TO="$2" shift 2 if ! aptkey_execute "$GPG_SH" --keyring "$(dearmor_filename "$FROM")" --export "$@" > "$TO" 2> "${GPGHOMEDIR}/gpgoutput.log"; then cat >&2 "${GPGHOMEDIR}/gpgoutput.log" false else chmod 0644 -- "$TO" fi } import_keyring_into_keyring() { local FROM="${1:-${GPGHOMEDIR}/pubring.gpg}" local TO="${2:-${GPGHOMEDIR}/pubring.gpg}" shift 2 rm -f "${GPGHOMEDIR}/gpgoutput.log" # the idea is simple: We take keys from one keyring and copy it to another # we do this with so many checks in between to ensure that WE control the # creation, so we know that the (potentially) created $TO keyring is a # simple keyring rather than a keybox as gpg2 would create it which in turn # can't be read by gpgv. # BEWARE: This is designed more in the way to work with the current # callers, than to have a well defined it would be easy to add new callers to. if [ ! -s "$TO" ]; then if [ -s "$FROM" ]; then if [ -z "$2" ]; then local OPTS if [ "${TO##*.}" = 'asc' ]; then OPTS='--armor' fi export_key_from_to "$(dearmor_filename "$FROM")" "$TO" $OPTS ${1:+"$1"} else create_new_keyring "$TO" fi else create_new_keyring "$TO" fi elif [ -s "$FROM" ]; then local EXPORTLIMIT="$1" if [ -n "$1$2" ]; then shift; fi local DEARMORTO="$(dearmor_filename "$TO")" if ! aptkey_execute "$GPG_SH" --keyring "$(dearmor_filename "$FROM")" --export ${EXPORTLIMIT:+"$EXPORTLIMIT"} \ | aptkey_execute "$GPG_SH" --keyring "$DEARMORTO" --batch --import "$@" > "${GPGHOMEDIR}/gpgoutput.log" 2>&1; then cat >&2 "${GPGHOMEDIR}/gpgoutput.log" false fi if [ "$DEARMORTO" != "$TO" ]; then export_key_from_to "$DEARMORTO" "${DEARMORTO}.asc" --armor if ! cmp -s "$TO" "${DEARMORTO}.asc" 2>/dev/null; then cp -a "$TO" "${TO}~" mv -f "${DEARMORTO}.asc" "$TO" fi fi fi } dearmor_keyring() { # https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=831409#67 # The awk script is more complex through to skip surrounding garbage and # to support multiple keys in one file (old gpgs generate version headers # which get printed with the original and hence result in garbage input for base64 awk '/^-----BEGIN/{ x = 1; } /^$/{ if (x == 1) { x = 2; }; } /^[^=-]/{ if (x == 2) { print $0; }; } /^-----END/{ x = 0; }' | base64 -d } dearmor_filename() { if [ "${1##*.}" = 'asc' ]; then local trusted="${GPGHOMEDIR}/${1##*/}.gpg" if [ -s "$1" ]; then dearmor_keyring < "$1" > "$trusted" fi echo "$trusted" elif [ "${1##*.}" = 'gpg' ]; then echo "$1" elif [ "$(head -n 1 "$1" 2>/dev/null)" = '-----BEGIN PGP PUBLIC KEY BLOCK-----' ]; then local trusted="${GPGHOMEDIR}/${1##*/}.gpg" dearmor_keyring < "$1" > "$trusted" echo "$trusted" else echo "$1" fi } catfile() { cat "$(dearmor_filename "$1")" >> "$2" } merge_all_trusted_keyrings_into_pubring() { # does the same as: # foreach_keyring_do 'import_keys_from_keyring' "${GPGHOMEDIR}/pubring.gpg" # but without using gpg, just cat and find local PUBRING="$(readlink -f "${GPGHOMEDIR}")/pubring.gpg" rm -f "$PUBRING" touch "$PUBRING" foreach_keyring_do 'catfile' "$PUBRING" } import_keys_from_keyring() { import_keyring_into_keyring "$1" "$2" } merge_keys_into_keyrings() { import_keyring_into_keyring "$2" "$1" '' --import-options 'merge-only' } merge_back_changes() { if [ -n "$FORCED_KEYRING" ]; then # if the keyring was forced merge is already done if [ "$FORCED_KEYRING" != "$TRUSTEDFILE" ]; then mv -f "$FORCED_KEYRING" "${FORCED_KEYRING}~" export_key_from_to "$TRUSTEDFILE" "$FORCED_KEYRING" --armor fi return fi if [ -s "${GPGHOMEDIR}/pubring.gpg" ]; then # merge all updated keys foreach_keyring_do 'merge_keys_into_keyrings' "${GPGHOMEDIR}/pubring.gpg" fi # look for keys which were added or removed get_fingerprints_of_keyring "${GPGHOMEDIR}/pubring.orig.gpg" > "${GPGHOMEDIR}/pubring.orig.keylst" get_fingerprints_of_keyring "${GPGHOMEDIR}/pubring.gpg" > "${GPGHOMEDIR}/pubring.keylst" comm -3 "${GPGHOMEDIR}/pubring.keylst" "${GPGHOMEDIR}/pubring.orig.keylst" > "${GPGHOMEDIR}/pubring.diff" # key isn't part of new keyring, so remove cut -f 2 "${GPGHOMEDIR}/pubring.diff" | while read key; do if [ -z "$key" ]; then continue; fi foreach_keyring_do 'remove_key_from_keyring' "$key" done # key is only part of new keyring, so we need to import it cut -f 1 "${GPGHOMEDIR}/pubring.diff" | while read key; do if [ -z "$key" ]; then continue; fi import_keyring_into_keyring '' "$TRUSTEDFILE" "$key" done } setup_merged_keyring() { if [ -n "$FORCED_KEYID" ]; then merge_all_trusted_keyrings_into_pubring FORCED_KEYRING="${GPGHOMEDIR}/forcedkeyid.gpg" TRUSTEDFILE="${FORCED_KEYRING}" echo "#!/bin/sh exec sh '($(escape_shell "${GPG}")' --keyring '$(escape_shell "${TRUSTEDFILE}")' \"\$@\"" > "${GPGHOMEDIR}/gpg.1.sh" GPG="${GPGHOMEDIR}/gpg.1.sh" # ignore error as this "just" means we haven't found the forced keyid and the keyring will be empty import_keyring_into_keyring '' "$TRUSTEDFILE" "$FORCED_KEYID" || true elif [ -z "$FORCED_KEYRING" ]; then merge_all_trusted_keyrings_into_pubring if [ -r "${GPGHOMEDIR}/pubring.gpg" ]; then cp -a "${GPGHOMEDIR}/pubring.gpg" "${GPGHOMEDIR}/pubring.orig.gpg" else touch "${GPGHOMEDIR}/pubring.gpg" "${GPGHOMEDIR}/pubring.orig.gpg" fi echo "#!/bin/sh exec sh '$(escape_shell "${GPG}")' --keyring '$(escape_shell "${GPGHOMEDIR}/pubring.gpg")' \"\$@\"" > "${GPGHOMEDIR}/gpg.1.sh" GPG="${GPGHOMEDIR}/gpg.1.sh" else TRUSTEDFILE="$(dearmor_filename "$FORCED_KEYRING")" create_new_keyring "$TRUSTEDFILE" echo "#!/bin/sh exec sh '$(escape_shell "${GPG}")' --keyring '$(escape_shell "${TRUSTEDFILE}")' \"\$@\"" > "${GPGHOMEDIR}/gpg.1.sh" GPG="${GPGHOMEDIR}/gpg.1.sh" fi } create_new_keyring() { # gpg defaults to mode 0600 for new keyrings. Create one with 0644 instead. if ! [ -e "$1" ]; then if [ -w "$(dirname "$1")" ]; then touch -- "$1" chmod 0644 -- "$1" fi fi } aptkey_execute() { sh "$@"; } usage() { echo "Usage: apt-key [--keyring file] [command] [arguments]" echo echo "Manage apt's list of trusted keys" echo echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)" echo " apt-key del <keyid> - remove the key <keyid>" echo " apt-key export <keyid> - output the key <keyid>" echo " apt-key exportall - output all trusted keys" echo " apt-key update - update keys using the keyring package" echo " apt-key net-update - update keys using the network" echo " apt-key list - list keys" echo " apt-key finger - list fingerprints" echo " apt-key adv - pass advanced options to gpg (download key)" echo echo "If no specific keyring file is given the command applies to all keyring files." } while [ -n "$1" ]; do case "$1" in --keyring) shift TRUSTEDFILE="$1" FORCED_KEYRING="$1" ;; --keyid) shift FORCED_KEYID="$1" ;; --secret-keyring) shift FORCED_SECRET_KEYRING="$1" ;; --readonly) merge_back_changes() { true; } create_new_keyring() { if [ ! -r "$FORCED_KEYRING" ]; then TRUSTEDFILE='/dev/null'; FORCED_KEYRING="$TRUSTEDFILE"; fi; } ;; --fakeroot) requires_root() { true; } ;; --quiet) aptkey_echo() { true; } ;; --debug1) # some cmds like finger redirect stderr to /dev/null … aptkey_execute() { echo 'EXEC:' "$@"; sh "$@"; } ;; --debug2) # … other more complicated ones pipe gpg into gpg. aptkey_execute() { echo >&2 'EXEC:' "$@"; sh "$@"; } ;; --homedir) # force usage of a specific homedir instead of creating a temporary shift GPGHOMEDIR="$1" ;; --*) echo >&2 "Unknown option: $1" usage exit 1;; *) break;; esac shift done if [ -z "$TRUSTEDFILE" ]; then TRUSTEDFILE="/etc/apt/trusted.gpg" eval $(apt-config shell TRUSTEDFILE Apt::GPGV::TrustedKeyring) eval $(apt-config shell TRUSTEDFILE Dir::Etc::Trusted/f) fi command="$1" if [ -z "$command" ]; then usage exit 1 fi shift find_gpgv_status_fd() { while [ -n "$1" ]; do if [ "$1" = '--status-fd' ]; then shift echo "$1" break fi shift done } GPGSTATUSFD="$(find_gpgv_status_fd "$@")" apt_warn() { if [ -z "$GPGHOMEDIR" ]; then echo >&2 'W:' "$@" else echo 'W:' "$@" > "${GPGHOMEDIR}/aptwarnings.log" fi if [ -n "$GPGSTATUSFD" ]; then echo >&${GPGSTATUSFD} '[APTKEY:] WARNING' "$@" fi } apt_error() { if [ -z "$GPGHOMEDIR" ]; then echo >&2 'E:' "$@" else echo 'E:' "$@" > "${GPGHOMEDIR}/aptwarnings.log" fi if [ -n "$GPGSTATUSFD" ]; then echo >&${GPGSTATUSFD} '[APTKEY:] ERROR' "$@" fi } cleanup_gpg_home() { if [ -z "$GPGHOMEDIR" ]; then return; fi if [ -s "$GPGHOMEDIR/aptwarnings.log" ]; then cat >&2 "$GPGHOMEDIR/aptwarnings.log" fi if command_available 'gpgconf'; then GNUPGHOME="${GPGHOMEDIR}" gpgconf --kill gpg-agent >/dev/null 2>&1 || true fi rm -rf "$GPGHOMEDIR" } # gpg needs (in different versions more or less) files to function correctly, # so we give it its own homedir and generate some valid content for it later on create_gpg_home() { # for cases in which we want to cache a homedir due to expensive setup if [ -n "$GPGHOMEDIR" ]; then return fi if [ -n "$TMPDIR" ]; then # tmpdir is a directory and current user has rwx access to it # same tests as in apt-pkg/contrib/fileutl.cc GetTempDir() if [ ! -d "$TMPDIR" ] || [ ! -r "$TMPDIR" ] || [ ! -w "$TMPDIR" ] || [ ! -x "$TMPDIR" ]; then unset TMPDIR fi fi GPGHOMEDIR="$(mktemp --directory --tmpdir 'apt-key-gpghome.XXXXXXXXXX')" CURRENTTRAP="${CURRENTTRAP} cleanup_gpg_home;" trap "${CURRENTTRAP}" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM if [ -z "$GPGHOMEDIR" ]; then apt_error "Could not create temporary gpg home directory in $TMPDIR (wrong permissions?)" exit 28 fi chmod 700 "$GPGHOMEDIR" } prepare_gpg_home() { # crude detection if we are called from a maintainerscript where the # package depends on gnupg or not. We accept recommends here as # well as the script hopefully uses apt-key optionally then like e.g. # debian-archive-keyring for (upgrade) cleanup did if [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ] && [ -z "$APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE" ]; then if ! dpkg-query --show --showformat '${Pre-Depends}${Depends}${Recommends}\n' "$DPKG_MAINTSCRIPT_PACKAGE" 2>/dev/null | grep -q gnupg; then cat >&2 <<EOF Warning: The $DPKG_MAINTSCRIPT_NAME maintainerscript of the package $DPKG_MAINTSCRIPT_PACKAGE Warning: seems to use apt-key (provided by apt) without depending on gnupg or gnupg2. Warning: This will BREAK in the future and should be fixed by the package maintainer(s). Note: Check first if apt-key functionality is needed at all - it probably isn't! EOF fi fi eval "$(apt-config shell GPG_EXE Apt::Key::gpgcommand)" if [ -n "$GPG_EXE" ] && command_available "$GPG_EXE"; then true elif command_available 'gpg'; then GPG_EXE="gpg" elif command_available 'gpg2'; then GPG_EXE="gpg2" elif command_available 'gpg1'; then GPG_EXE="gpg1" else apt_error 'gnupg, gnupg2 and gnupg1 do not seem to be installed, but one of them is required for this operation' exit 255 fi create_gpg_home # now tell gpg that it shouldn't try to maintain this trustdb file echo "#!/bin/sh exec '$(escape_shell "${GPG_EXE}")' --ignore-time-conflict --no-options --no-default-keyring \\ --homedir '$(escape_shell "${GPGHOMEDIR}")' --no-auto-check-trustdb --trust-model always \"\$@\"" > "${GPGHOMEDIR}/gpg.0.sh" GPG_SH="${GPGHOMEDIR}/gpg.0.sh" GPG="$GPG_SH" # create the trustdb with an (empty) dummy keyring # older gpgs required it, newer gpgs even warn that it isn't needed, # but require it nonetheless for some commands, so we just play safe # here for the foreseeable future and create a dummy one touch "${GPGHOMEDIR}/empty.gpg" if ! "$GPG_EXE" --ignore-time-conflict --no-options --no-default-keyring \ --homedir "$GPGHOMEDIR" --quiet --check-trustdb --keyring "${GPGHOMEDIR}/empty.gpg" >"${GPGHOMEDIR}/gpgoutput.log" 2>&1; then cat >&2 "${GPGHOMEDIR}/gpgoutput.log" false fi # We don't usually need a secret keyring, of course, but # for advanced operations, we might really need a secret keyring after all if [ -n "$FORCED_SECRET_KEYRING" ] && [ -r "$FORCED_SECRET_KEYRING" ]; then if ! aptkey_execute "$GPG" -v --batch --import "$FORCED_SECRET_KEYRING" >"${GPGHOMEDIR}/gpgoutput.log" 2>&1; then # already imported keys cause gpg1 to fail for some reason… ignore this error if ! grep -q 'already in secret keyring' "${GPGHOMEDIR}/gpgoutput.log"; then cat >&2 "${GPGHOMEDIR}/gpgoutput.log" false fi fi else # and then, there are older versions of gpg which panic and implode # if there isn't one available - and writeable for imports # and even if not output is littered with the creation of a secring, # so lets call import once to have it create what it wants in silence echo -n | aptkey_execute "$GPG" --batch --import >/dev/null 2>&1 || true fi } warn_on_script_usage() { if [ -n "$APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE" ]; then return fi # (Maintainer) scripts should not be using apt-key if [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ]; then echo >&2 "Warning: apt-key should not be used in scripts (called from $DPKG_MAINTSCRIPT_NAME maintainerscript of the package ${DPKG_MAINTSCRIPT_PACKAGE})" elif [ ! -t 1 ]; then echo >&2 "Warning: apt-key output should not be parsed (stdout is not a terminal)" fi } if [ "$command" != 'help' ] && [ "$command" != 'verify' ]; then prepare_gpg_home fi case "$command" in add) warn_on_script_usage requires_root setup_merged_keyring aptkey_execute "$GPG" --quiet --batch --import "$@" merge_back_changes aptkey_echo "OK" ;; del|rm|remove) # no script warning here as removing 'add' usage needs 'del' for cleanup requires_root foreach_keyring_do 'remove_key_from_keyring' "$@" aptkey_echo "OK" ;; update) warn_on_script_usage requires_root setup_merged_keyring update merge_back_changes ;; net-update) requires_root setup_merged_keyring net_update merge_back_changes ;; list|finger*) warn_on_script_usage foreach_keyring_do 'list_keys_in_keyring' --fingerprint "$@" ;; export|exportall) warn_on_script_usage merge_all_trusted_keyrings_into_pubring aptkey_execute "$GPG_SH" --keyring "${GPGHOMEDIR}/pubring.gpg" --armor --export "$@" ;; adv*) warn_on_script_usage setup_merged_keyring aptkey_echo "Executing: $GPG" "$@" aptkey_execute "$GPG" "$@" merge_back_changes ;; verify) GPGV='' eval $(apt-config shell GPGV Apt::Key::gpgvcommand) if [ -n "$GPGV" ] && command_available "$GPGV"; then true; elif command_available 'gpgv'; then GPGV='gpgv'; elif command_available 'gpgv2'; then GPGV='gpgv2'; elif command_available 'gpgv1'; then GPGV='gpgv1'; else apt_error 'gpgv, gpgv2 or gpgv1 required for verification, but neither seems installed' exit 29 fi # for a forced keyid we need gpg --export, so full wrapping required if [ -n "$FORCED_KEYID" ]; then prepare_gpg_home else create_gpg_home fi setup_merged_keyring if [ -n "$FORCED_KEYRING" ]; then "$GPGV" --homedir "${GPGHOMEDIR}" --keyring "$(dearmor_filename "${FORCED_KEYRING}")" --ignore-time-conflict "$@" else "$GPGV" --homedir "${GPGHOMEDIR}" --keyring "${GPGHOMEDIR}/pubring.gpg" --ignore-time-conflict "$@" fi ;; help) usage ;; *) usage exit 1 ;; esac